<div fxFlex fxLayout="row" class="container">
  <h1 class="kd-header">Days off</h1>
  <mat-divider></mat-divider>
  <div class="kd-div-top-spacer"></div>
  <div style="padding-top: 30px;"></div>

  <h3 *ngIf="authService.isLoggedUser(); else showRequestsTitle" class="kd-header">
    Request day off
  </h3>
  <ng-template #showRequestsTitle>
    <h3 class="kd-header">Employee requests</h3>
  </ng-template>
  <div class="kd-div-top-spacer"></div>

  <div *ngIf="authService.isLoggedUser(); else loggedOwner">
    <div class="form-group form-row">
      <div class="col-md-3">
        <h4>Start date</h4>
        <mat-form-field class="kd-date">
          <input matInput [matDatepicker]="picker" [(ngModel)]="datePicker" placeholder="Select date">
            <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
            <mat-datepicker #picker></mat-datepicker>
        </mat-form-field>
      </div>
      <div class="col-md-2"></div>
      <div class="col-md-3">
        <h4>Type (reason)</h4>
        <select class="select" [(ngModel)]="selectedType">
         <option *ngFor="let type of typeOptions" [ngValue]="type">
           {{ type }}
         </option>
        </select>
      </div>
    </div>
    <div class="kd-div-top-spacer"></div>

    <button class="btn kd-request-day-off" (click)="onCreateRequest()">
      <div class="kd-inline">
        <mat-icon>date_range</mat-icon>
        <span class="kd-inline-text">Send request</span>
      </div>
    </button>
    <div class="kd-div-top-spacer"></div>
    <div style="padding-top: 30px;"></div>

    <h2 class="kd-header">History</h2>
    <mat-divider></mat-divider>
    <div class="kd-div-top-spacer"></div>

    <table *ngIf="showHistoryTable(); else emptyHistory">
      <tr>
        <th>Date</th>
        <th>Type</th>
        <th>Approved</th>
        <th>Edit</th>
        <th>Remove</th>
      </tr>
      <tr *ngFor="let dayOff of daysOff | approved: true">
        <td>{{ dayOff.date | date }}</td>
        <td>{{ dayOff.dayType === 'sick_day' ? 'Sick day' : 'Vacation' }}</td>
        <td>
          <mat-icon class="kd-approved">thumb_up_alt</mat-icon>
        </td>
        <td>
          <mat-icon class="kd-edit" (click)="onEditRequest(dayOff)">
            create
          </mat-icon>
        </td>
        <td>
          <mat-icon class="kd-remove-danger" (click)="onRemoveRequest(dayOff)">
            clear
          </mat-icon>
        </td>
      </tr>
      <tr *ngFor="let dayOff of daysOff | approved: false">
        <td>{{ dayOff.date | date }}</td>
        <td>{{ dayOff.dayType === 'sick_day' ? 'Sick day' : 'Vacation' }}</td>
        <td>
          <mat-icon class="kd-disapproved">thumb_down_alt</mat-icon>
        </td>
        <td>
          <!-- Edit nije implementiran -->
          <mat-icon class="kd-edit" (click)="onEditRequest(dayOff)">
            create
          </mat-icon>
        </td>
        <td>
          <mat-icon class="kd-remove-danger" (click)="onRemoveRequest(dayOff)">
            clear
          </mat-icon>
        </td>
      </tr>
    </table>
    <ng-template #emptyHistory>
      History is empty ...
    </ng-template>
  </div>

  <ng-template #loggedOwner>
    <div *ngIf="showUserDaysOff(); else noUserDaysOff">
      <div *ngFor="let userDaysOff of allDaysOff">
        <div *ngIf="userHasDaysOffRequests(userDaysOff); else noUserRequests">
          <h4 class="kd-header">
            {{ userDaysOff.user.firstname }} {{ userDaysOff.user.lastname }}
          </h4>
          <div style="padding-top: 10px;"></div>
        </div>

        <table>
          <tr>
            <th>Date</th>
            <th>Type (reason)</th>
            <th>Approve?</th>
            <th>Remove</th>
          </tr>
          <tr *ngFor="let dayOff of userDaysOff.daysOff">
            <td>{{ dayOff.date | date }}</td>
            <td>{{ dayOff.dayType }}</td>
            <td>
              <mat-icon class="kd-check" (click)="onApproveRequest(dayOff)">
                check
              </mat-icon>
            </td>
            <td>
              <mat-icon class="kd-remove-danger" (click)="onRemoveRequest(dayOff)">
                clear
              </mat-icon>
            </td>
          </tr>
        </table>
        <div class="kd-div-top-spacer"></div>
        <div class="padding-top: 30px;"></div>

        <ng-template #noUserRequests>
          No requests for this employee
        </ng-template>
      </div>
    </div>

    <ng-template #noUserDaysOff>
      No requests from employees
    </ng-template>
  </ng-template>

</div>
